CustomScoreQuery (Lucene 2.4.1 API)
Keywords: org.apache.lucene.search.function.CustomScoreQuery class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search.function
Class CustomScoreQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.function.CustomScoreQuery

All Implemented Interfaces:
  Serializable, Cloneable

    public class CustomScoreQuery

extends Query

Query that sets document score as a programmatic function of several (sub) scores.

1. the score of its subQuery (any query)
2. (optional) the score of its ValueSourceQuery (or queries). For most simple/convenient use cases this query is likely to be a `FieldScoreQuery`

Subclasses can modify the computation by overriding `customScore(int, float, float)`.

WARNING: The status of the search.function package is experimental. The APIs introduced here might change in the future and will not be supported anymore in such a case.

See Also:
  Serialized Form

Constructor Summary
`CustomScoreQuery(Query subQuery)` Create a CustomScoreQuery over input subQuery.
`CustomScoreQuery(Query subQuery, ValueSourceQuery valSrcQuery)` Create a CustomScoreQuery over input subQuery and a `ValueSourceQuery`.
`CustomScoreQuery(Query subQuery, ValueSourceQuery[] valSrcQueries)` Create a CustomScoreQuery over input subQuery and a `ValueSourceQuery`.

Method Summary
`Object` | `clone()` Returns a clone of this query.
`protected Weight` | `createWeight(Searcher searcher)` Expert: Constructs an appropriate Weight implementation for this query.
`Explanation` | `customExplain(int doc, Explanation subQueryExpl, Explanation valSrcExpl)` Explain the custom score.
`Explanation` | `customExplain(int doc, Explanation subQueryExpl, Explanation[] valSrcExpls)` Explain the custom score.
`float` | `customScore(int doc, float subQueryScore, float valSrcScore)` Compute a custom score by the subQuery score and the ValueSourceQuery score.
`float` | `customScore(int doc, float subQueryScore, float[] valSrcScores)` Compute a custom score by the subQuery score and a number of ValueSourceQuery scores.
`boolean` | `equals(Object o)` Returns true if `o` is equal to this.
`void` | `extractTerms(Set terms)` Expert: adds all terms occuring in this query to the terms set.
`int` | `hashCode()` Returns a hash code value for this object.
`boolean` | `isStrict()` Checks if this is strict custom scoring.
`String` | `name()` A short name of this query, used in `toString(String)`.
`Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`void` | `setStrict(boolean strict)` Set the strict mode of this query.
`String` | `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

Methods inherited from class org.apache.lucene.search.Query
`combine, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CustomScoreQuery

    public CustomScoreQuery(Query subQuery)

  Create a CustomScoreQuery over input subQuery.

  Parameters:
    `subQuery` - the sub query whose scored is being customed. Must not be null.

### CustomScoreQuery

    public CustomScoreQuery(Query subQuery,
                            ValueSourceQuery valSrcQuery)

  Create a CustomScoreQuery over input subQuery and a `ValueSourceQuery`.

  Parameters:
    `subQuery` - the sub query whose score is being customed. Must not be null.
    `valSrcQuery` - a value source query whose scores are used in the custom score computation. For most simple/convineient use case this would be a `FieldScoreQuery`. This parameter is optional - it can be null.

### CustomScoreQuery

    public CustomScoreQuery(Query subQuery,
                            ValueSourceQuery[] valSrcQueries)

  Create a CustomScoreQuery over input subQuery and a `ValueSourceQuery`.

  Parameters:
    `subQuery` - the sub query whose score is being customed. Must not be null.
    `valSrcQueries` - value source queries whose scores are used in the custom score computation. For most simple/convineient use case these would be `FieldScoreQueries`. This parameter is optional - it can be null or even an empty array.

Method Detail

### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

  Description copied from class: `Query`
  Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `IOException`

### extractTerms

    public void extractTerms(Set terms)

  Description copied from class: `Query`
  Expert: adds all terms occuring in this query to the terms set. Only works if this query is in its `rewritten` form.

  Overrides:
    `extractTerms` in class `Query`

### clone

    public Object clone()

  Description copied from class: `Query`
  Returns a clone of this query.

  Overrides:
    `clone` in class `Query`

### toString

    public String toString(String field)

  Description copied from class: `Query`
  Prints a query to a string, with `field` assumed to be the default field and omitted.

  The representation used is one that is supposed to be readable by `QueryParser`. However, there are the following limitations:

  - If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.
  - Some of the more complicated queries (e.g. span queries) don't have a representation that can be parsed by QueryParser.

  Specified by:
    `toString` in class `Query`

### equals

    public boolean equals(Object o)

  Returns true if `o` is equal to this.

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Returns a hash code value for this object.

  Overrides:
    `hashCode` in class `Object`

### customScore

    public float customScore(int doc,
                             float subQueryScore,
                             float[] valSrcScores)

  Compute a custom score by the subQuery score and a number of ValueSourceQuery scores.

  Subclasses can override this method to modify the custom score.

  If your custom scoring is different than the default herein you should override at least one of the two customScore() methods. If the number of ValueSourceQueries is always < 2 it is sufficient to override the other `costomScore()` method, which is simpler.

  The default computation herein is:

           ModifiedScore = valSrcScore * subQueryScore[0] * subQueryScore[1] * ...

  Parameters:
    `doc` - id of scored doc.
    `subQueryScore` - score of that doc by the subQuery.
    `valSrcScores` - score of that doc by the ValueSourceQuery.
  Returns:
    custom score.

### customScore

    public float customScore(int doc,
                             float subQueryScore,
                             float valSrcScore)

  Compute a custom score by the subQuery score and the ValueSourceQuery score.

  Subclasses can override this method to modify the custom score.

  If your custom scoring is different than the default herein you should override at least one of the two customScore() methods. If the number of ValueSourceQueries is always < 2 it is sufficient to override this costomScore() method, which is simpler.

  The default computation herein is:

           ModifiedScore = valSrcScore * subQueryScore

  Parameters:
    `doc` - id of scored doc.
    `subQueryScore` - score of that doc by the subQuery.
    `valSrcScore` - score of that doc by the ValueSourceQuery.
  Returns:
    custom score.

### customExplain

    public Explanation customExplain(int doc,
                                     Explanation subQueryExpl,
                                     Explanation[] valSrcExpls)

  Explain the custom score. Whenever overriding `customScore(int, float, float[])`, this method should also be overridden to provide the correct explanation for the part of the custom scoring.

  Parameters:
    `doc` - doc being explained.
    `subQueryExpl` - explanation for the sub-query part.
    `valSrcExpls` - explanation for the value source part.
  Returns:
    an explanation for the custom score

### customExplain

    public Explanation customExplain(int doc,
                                     Explanation subQueryExpl,
                                     Explanation valSrcExpl)

  Explain the custom score. Whenever overriding `customScore(int, float, float)`, this method should also be overridden to provide the correct explanation for the part of the custom scoring.

  Parameters:
    `doc` - doc being explained.
    `subQueryExpl` - explanation for the sub-query part.
    `valSrcExpl` - explanation for the value source part.
  Returns:
    an explanation for the custom score

### createWeight

    protected Weight createWeight(Searcher searcher)
                           throws IOException

  Description copied from class: `Query`
  Expert: Constructs an appropriate Weight implementation for this query.

  Only implemented by primitive queries, which re-write to themselves.

  Overrides:
    `createWeight` in class `Query`
  Throws:
    `IOException`

### isStrict

    public boolean isStrict()

  Checks if this is strict custom scoring. In strict custom scoring, the ValueSource part does not participate in weight normalization. This may be useful when one wants full control over how scores are modified, and does not care about normalizing by the ValueSource part. One particular case where this is useful if for testing this query.

  Note: only has effect when the ValueSource part is not null.

### setStrict

    public void setStrict(boolean strict)

  Set the strict mode of this query.

  Parameters:
    `strict` - The strict mode to set.
  See Also:
    `isStrict()`

### name

    public String name()

  A short name of this query, used in `toString(String)`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.